use serde::Deserialize;
use crate::model::travelynx::TrainType;

#[derive(Debug, Deserialize)]
pub struct TrainOrdering {
    #[serde(rename = "fahrzeuggruppen")]
    pub train_sets: Vec<TrainSet>,
}

#[derive(Debug, Deserialize)]
pub struct TrainSet {
    #[serde(rename = "bezeichnung")]
    pub identifier: String,
    #[serde(rename = "fahrtreferenz")]
    pub journey: Journey,
}

#[derive(Debug, Deserialize)]
pub struct Journey {
    #[serde(rename = "typ")]
    pub category: String,
    #[serde(rename = "gattung")]
    pub train_type: TrainType,
    #[serde(rename = "fahrtnummer")]
    pub trip_number: usize,
}
