use serde::{Deserialize, Serialize};

#[derive(Debug, Clone, Serialize, Deserialize)]
pub(crate) struct UIC {
    type_code: TypeCode,
    country_code: CountryCode,
    national_block: NationalBlock,
    check: char,
}

#[derive(Debug, Clone, Serialize, Deserialize)]
enum TypeCode {
    Miscellaneous = 90,
    ElectricLocomotive = 91,
    DieselLocomotive = 92,
    ElectricMultipleUnitHighSpeed = 93,
    ElectricMultipleUnitLowSpeed = 94,
    DieselMultipleUnit = 95,
    SpecialisedTrailer = 96,
    ElectricShunter = 97,
    DieselShunter = 98,
    SpecialVehicle = 99,
}

#[derive(Debug, Clone, Serialize, Deserialize)]
enum CountryCode {
    Finland = 10,
    Russia = 20,
    Belarus = 21,
    Ukraine = 22,
    Moldova = 23,
    Lithuania = 24,
    Latvia = 25,
    Estonia = 26,
    Kazakhstan = 27,
    Georgia = 28,
    Uzbekistan = 29,
    NorthKorea = 30,
    Mongolia = 31,
    Vietnam = 32,
    China = 33,
    Laos = 34,
    Cuba = 40,
    Albania = 41,
    Japan = 42,
    SerbRepublicOfBosniaHerzegovina = 44,
    BosniaHerzegovina = 49,
    MuslimCroatFederationOfBosniaHerzegovina = 50,
    Poland = 51,
    Bulgaria = 52,
    Romania = 53,
    CzechRepublic = 54,
    Hungary = 55,
    Slovakia = 56,
    Azerbaijan = 57,
    Armenia = 58,
    Kyrgyzstan = 59,
    Ireland = 60,
    SouthKorea = 61,
    Montenegro = 62,
    NorthMacedonia = 65,
    Tajikistan = 66,
    Turkmenistan = 67,
    Afghanistan = 68,
    UnitedKingdom = 70,
    Spain = 71,
    Serbia = 72,
    GreeceKingdom = 73,
    Sweden = 74,
    Turkey = 75,
    Norway = 76,
    Croatia = 78,
    Slovenia = 79,
    Germany = 80,
    Austria = 81,
    Luxembourg = 82,
    Italian = 83,
    Netherlands = 84,
    Switzerland = 85,
    Denmark = 86,
    France = 87,
    Belgium = 88,
    Tanzania = 89,
    Egypt = 90,
    Tunesia = 91,
    Algeria = 92,
    Marocco = 93,
    Portugal = 94,
    Israel = 95,
    Iran = 96,
    Syriac = 97,
    Lebanon = 98,
    Iraq = 99,
}
#[derive(Debug, Clone, Serialize, Deserialize)]
struct NationalBlock {
    digits: [char; 7],
}