CREATE TABLE IF NOT EXISTS triebzug (
    uuid	    UUID     PRIMARY KEY,
    tz_id       INT      NOT NULL UNIQUE,
    name        VARCHAR NULL,
    UNIQUE (uuid)
);

CREATE TABLE IF NOT EXISTS bingo_cards (
    uuid        UUID    PRIMARY KEY,
    start_time  INT     NOT NULL,
    end_time    INT     NOT NULL
);

CREATE TABLE IF NOT EXISTS bingo_card (
    uuid        UUID    NOT NULL,
    x_pos       INT     NOT NULL,
    y_pos       INT     NOT NULL,
    triebzug    UUID    NOT NULL REFERENCES triebzug(uuid),
    card_uuid   UUID    NOT NULL REFERENCES bingo_cards(uuid),
    PRIMARY KEY (uuid, x_pos, y_pos)
);

CREATE TABLE IF NOT EXISTS "user" (
    uuid        UUID            PRIMARY KEY,
    name        VARCHAR         NOT NULL
);

CREATE TABLE IF NOT EXISTS webhook (
    uuid        UUID            PRIMARY KEY,
    "user"      UUID            NOT NULL REFERENCES "user" (uuid),
    token       VARCHAR         NOT NULL
);

CREATE TABLE IF NOT EXISTS checkins (
    uuid        UUID            PRIMARY KEY,
    "user"      UUID            NOT NULL REFERENCES "user" (uuid),
    train       UUID            NOT NULL REFERENCES triebzug(uuid),
    start_time  TIMESTAMP       NOT NULL,
    end_time    TIMESTAMP       NULL
);

CREATE INDEX tz_id ON triebzug(tz_id);
CREATE INDEX bingo_card_xy ON bingo_card(x_pos, y_pos);
CREATE INDEX bingo_card_uuid ON bingo_card(uuid);
